// File: UMain
// Date: 17.10.2012
//    
// : GetAdaptersAddresses/GetAdaptersInfo

unit UMain;

interface

uses
  Windows,  SysUtils,  Classes,  Controls,  Forms,
  StdCtrls,  ComCtrls,  Dialogs, Winsock2, IpHlpApi, IpTypes;
  //  "IpTypes,  IpHlpApi"  "Winsock2"         (21.10.2012)

type
  TFMain = class(TForm)
    lv_net: TListView;
    procedure lv_netData(Sender: TObject; Item: TListItem);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function getnameinfo(sa: PSockAddr; salen: DWORD; host: PChar; hostlen: DWORD; serv: PChar; servlen: DWORD; flags: Integer): Integer; stdcall; external 'ws2_32.dll' name 'getnameinfo';

var
  FMain: TFMain;
  gInfoStr: AnsiString;
  gsAdaList: TStringList;

implementation

{$R *.dfm}

//  
function GetAdaInfo2(out AInfoStr: AnsiString; const AOnlyMac: Boolean):Boolean;
const
  cntAdaCount=2;
  cntAdaTypesInt: array[0..cntAdaCount] of Cardinal = ($6, $47, $90);
  cntAdaTypesDef: array[0..cntAdaCount] of AnsiString =
                 ('Ethernet Network Adapter',
                  'Wireless Network Adapter',
                  'FireWire Network Adapter');
NI_MAXHOST = 1025;
NI_MAXSERV = 32;
NI_NUMERICHOST = $2;
NI_NUMERICSERV = $8;

var
  i: Integer;
  bf: Cardinal;
  LqFind: Boolean;
  LsMac: AnsiString;
  LpAdapterAddresses: PIP_ADAPTER_ADDRESSES;

  //*********************
  //p: PWideChar;
  //IP:String;
  host, serv: String;
  hostlen, servlen: integer;
  r: integer;
  m_data: WSADATA;
begin
  if WSAStartup($0202, m_data) <> 0 then
    Exit;

  Result := True;
  AInfoStr := '';
  try
    bf := 0;
    if GetAdaptersAddresses(0, 0, nil, nil, @bf) <> ERROR_BUFFER_OVERFLOW then Abort;
    try
      GetMem(LpAdapterAddresses, bf);
      if GetAdaptersAddresses(0, 0, nil, LpAdapterAddresses, @bf) <> ERROR_SUCCESS then Abort;

      while LpAdapterAddresses <> nil do
      begin
        try
          //   
          LqFind := False;
          for i := 0 to cntAdaCount do
            if LpAdapterAddresses^.IfType = cntAdaTypesInt[i] then
            begin
              LqFind := True;
              Break;
            end;

          if not LqFind then Continue;

          //   
          if not AOnlyMac then
            AInfoStr := Format('%s%s (%s)'#13#10'%s'#13#10,
                             [AInfoStr, LpAdapterAddresses^.FriendlyName,
                              LpAdapterAddresses^.Description, cntAdaTypesDef[i]]);

            //********************************************************************
            //  21.10.2012

            hostlen := NI_MAXHOST;     // 1025
            servlen := NI_MAXSERV;     // 32
            setlength(host, hostlen);
            setlength(serv, servlen);

            r := GetNameInfo(LpAdapterAddresses.FirstUnicastAddress.Address.lpSockaddr,
                             LpAdapterAddresses.FirstUnicastAddress.Address.iSockaddrLength,
                             PWideChar(host), hostlen,
                             PWideChar(serv), servlen, NI_NUMERICHOST);  // NI_NUMERICSERV


            //********************************************************************

          LsMac := '';
          if LpAdapterAddresses^.PhysicalAddressLength = 0 then Continue;

          for i := 0 to LpAdapterAddresses^.PhysicalAddressLength - 1 do
            LsMac := LsMac + IntToHex(LpAdapterAddresses^.PhysicalAddress[i], 2) + '-';
          SetLength(LsMac, Length(LsMac) - 1);
          AInfoStr := Format('%s%s'#13#10#13#10, [AInfoStr, LsMac]);
        finally
          LpAdapterAddresses := LpAdapterAddresses^.Next;
        end;
      end;
    finally
      FreeMem(LpAdapterAddresses, bf);
    end;
  except
    Result := False;
    AInfoStr := '';
  end;

  WSACleanup;

end;



procedure TFMain.lv_netData(Sender: TObject; Item: TListItem);
var
  i:Integer;
  LsTempList:TStringList;
begin
  try
    try
      LsTempList := TStringList.Create;
      LsTempList.Text := gsAdaList[Item.Index];
      Item.Caption := LsTempList[0];
      for i := 1 to LsTempList.Count-1 do
        Item.SubItems.Add(LsTempList[i]);
    finally
      FreeAndNil(LsTempList);
    end;
  except
  end;
end;


procedure TFMain.FormShow(Sender: TObject);
begin

  if not GetAdaInfo2(gInfoStr, False) then
    Exit; //     

  gsAdaList := TStringList.Create;
  gsAdaList.LineBreak := #13#10#13#10;
  gsAdaList.Text := gInfoStr;
  lv_net.AllocBy := gsAdaList.Count;


end;

procedure TFMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FreeAndNil(gsAdaList);
end;

end.
